############################################################################
#
# File Name: 		Collection.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Collection.py.html
#

"""
Base class for all collections
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

from Ft.Ods import Database
from Ft.Ods.StorageManager.Adapters import Constants

class Collection:

    _persistentType = Constants.ObjectTypes.COLLECTION

    def __init__(self,cid=None):
        if cid is None:
            #New Collection
            self.__dict__['_cid'] = 0
        else:
            #Recreated collection
            self.__dict__['_cid'] = cid

        # See if we are in a transaction
        self.__dict__['_db'] = Database.Database()
        if self._db._4ods_inTransaction():
            self.__dict__['_tx'] = self._db.current()
        else:
            self.__dict__['_tx'] = None

        if self._tx:
            if cid:
                self._tx._4ods_registerModifiedPersistentObject(self)
            else:
                self._tx._4ods_registerNewPersistentObject(self)


    def delete(self,recurse=0):
        if self._tx:
            self._tx._4ods_deletePersistentObject(self)

    def _4ods_getId(self):
        return self._cid

    def _4ods_setCid(self, cid):
        self.__dict__['_cid'] = cid

    _extents = ()
    _localExtents = ()

