############################################################################
#
# File Name: 		Bag.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Bag.py.html
#
"""
Bag: pretty much just a collection.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""


from Ft.Ods.StorageManager.Adapters import Constants


class BagBase:

    _collectionType = Constants.CollectionTypes.BAG

    def is_ordered(self):
        return 0

    def allows_duplicates(self):
        return 1


    def occurrences_of(self, element):
        return self.count(element)

    def create_union(self, other_bag):
        result = self.copy(deep=0)
        for item in other_bag:
            if self.contains_element(item):
                result.insert_element(item)
        return result

    def create_intersection(self, other_bag):
        result = self.copy(deep=0)
        for item in self:
            if not item in result:
                result.insert_element(item)
        for item in other_bag:
            if not item in result:
                result.insert_element(item)
        return result

    def create_difference(self, other_bag):
        result_list = []
        result = self.copy(deep=0)
        for item in other_bag:
            if not self.contains_element(item):
                result.append(item)
        for item in self:
            if not other_bag.contains_element(item):
                result.append(item)
        return result
