############################################################################
#
# File Name: 		LiteralCollection.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/List.py.html
#
"""
All of the Literal Collections
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

from Ft.Ods.Collections import CollectionOfPersistentObjects
from Ft.Ods.Collections import CollectionOfValues
from Ft.Ods.Collections import BagBase
from Ft.Ods.Collections import ListBase
from Ft.Ods.Collections import SetBase
from Ft.Ods.StorageManager.Adapters import Constants





class LiteralCollection:
    pass



#########################
#Collection of Objects
#########################

class LiteralBagOfObjects(CollectionOfPersistentObjects.CollectionOfPersistentObjects,
                          LiteralCollection,
                          BagBase.BagBase,
                          ):

    _pType = Constants.ObjectTypes.OBJECT
    #Override some inheritence
    allows_duplicates = BagBase.BagBase.allows_duplicates
    is_ordered = BagBase.BagBase.is_ordered
    typeId = Constants.Types.OBJECT_BAG
    _operationalBase = CollectionOfPersistentObjects.CollectionOfPersistentObjects

class LiteralListOfObjects(CollectionOfPersistentObjects.CollectionOfPersistentObjects,
                           LiteralCollection,
                           ListBase.ListBase,
                           ):

    _pType = Constants.ObjectTypes.OBJECT
    #Override some inheritence
    allows_duplicates = ListBase.ListBase.allows_duplicates
    is_ordered = ListBase.ListBase.is_ordered
    insert_element = ListBase.ListBase.insert_element
    append = ListBase.ListBase.append
    _operationalBase = CollectionOfPersistentObjects.CollectionOfPersistentObjects
    


class LiteralSetOfObjects(CollectionOfPersistentObjects.CollectionOfPersistentObjects,
                          LiteralCollection,
                          SetBase.SetBase,
                          ):

    _pType = Constants.ObjectTypes.OBJECT
    #Override some inheritence
    allows_duplicates = SetBase.SetBase.allows_duplicates
    is_ordered = SetBase.SetBase.is_ordered
    insert_element = SetBase.SetBase.insert_element
    _operationalBase = CollectionOfPersistentObjects.CollectionOfPersistentObjects



#################################
#Repository Object Collections
#################################


class LiteralBagOfRepositoryObjects(CollectionOfPersistentObjects.CollectionOfPersistentObjects,
                                    LiteralCollection,
                                    BagBase.BagBase
                                    ):

    _pType = Constants.ObjectTypes.REPO
    #Override some inheritence
    allows_duplicates = BagBase.BagBase.allows_duplicates
    is_ordered = BagBase.BagBase.is_ordered
    typeId = Constants.Types.OBJECT_BAG
    _operationalBase = CollectionOfPersistentObjects.CollectionOfPersistentObjects


class LiteralListOfRepositoryObjects(CollectionOfPersistentObjects.CollectionOfPersistentObjects,
                                     LiteralCollection,
                                     ListBase.ListBase,
                                     ):

    _pType = Constants.ObjectTypes.REPO
    #Override some inheritence
    allows_duplicates = ListBase.ListBase.allows_duplicates
    is_ordered = ListBase.ListBase.is_ordered
    insert_element = ListBase.ListBase.insert_element
    append = ListBase.ListBase.append
    typeId = Constants.Types.OBJECT_LIST
    _operationalBase = CollectionOfPersistentObjects.CollectionOfPersistentObjects


class LiteralSetOfRepositoryObjects(CollectionOfPersistentObjects.CollectionOfPersistentObjects,
                                    LiteralCollection,
                                    SetBase.SetBase,
                                    ):


    _pType = Constants.ObjectTypes.REPO
    #Override some inheritence
    allows_duplicates = SetBase.SetBase.allows_duplicates
    is_ordered = SetBase.SetBase.is_ordered
    typeId = Constants.Types.OBJECT_SET
    insert_element = SetBase.SetBase.insert_element
    _operationalBase = CollectionOfPersistentObjects.CollectionOfPersistentObjects



##############################
#Collection of Values
##############################


class LiteralBagOfValues(CollectionOfValues.CollectionOfValues,
                         LiteralCollection,
                         BagBase.BagBase
                         ):

    #Override some inheritence
    allows_duplicates = BagBase.BagBase.allows_duplicates
    is_ordered = BagBase.BagBase.is_ordered
    _operationalBase = CollectionOfValues.CollectionOfValues


class LiteralListOfValues(CollectionOfValues.CollectionOfValues,
                          LiteralCollection,
                          ListBase.ListBase,
                          ):

    #Override some inheritence
    allows_duplicates = ListBase.ListBase.allows_duplicates
    is_ordered = ListBase.ListBase.is_ordered
    insert_element = ListBase.ListBase.insert_element
    append = ListBase.ListBase.append
    _operationalBase = CollectionOfValues.CollectionOfValues


class LiteralSetOfValues(CollectionOfValues.CollectionOfValues,
                         LiteralCollection,
                         SetBase.SetBase,
                         ):

    #Override some inheritence
    allows_duplicates = SetBase.SetBase.allows_duplicates
    is_ordered = SetBase.SetBase.is_ordered
    insert_element = SetBase.SetBase.insert_element
    _operationalBase = CollectionOfValues.CollectionOfValues
