########################################################################
#
# File Name: 	        Expression.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Expression.py.html
#
"""
Implements the Expression meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""


from Ft.Ods.MetaData import Operand
from Ft.Ods.MetaData import MetaKind
from Ft.Ods.StorageManager.Adapters import Constants
from Ft.Ods.Collections import LiteralCollection

from Ft.Ods import PersistentObject
td = PersistentObject.TupleDefinitions


class Expression(Operand.Operand):
    def __init__(self,data=None):
        Operand.Operand.__init__(self,data,MetaKind.MetaKind.mk_expression)
        if data is None:
            self.__dict__['operator'] = ''


    def add_the_operands(self,target,inverse = 1):
        self._4ods_addRelationship('the_operands',Operand.Operand,'operand_in','form',target,inverse)
    form_the_operands = add_the_operands

    def remove_the_operands(self,target,inverse = 1):
        self._4ods_removeRelationship('the_operands','operand_in','drop',target,inverse)
    drop_the_operands=remove_the_operands


    _tupleNames =  ('operator','the_operands')

    _tupleDefinitions = {'operator':{td.TYPE:Constants.Types.STRING,
                                     },
                         'the_operands':{td.TYPE:Constants.Types.OBJECT_LIST,
                                         td.READONLY:1,
                                         td.RELATIONSHIP:1,
                                         td.COLLECTION_CLASS:LiteralCollection.LiteralListOfRepositoryObjects,
                                         },
                         }

    _localExtents = ()
