########################################################################
#
# File Name: 	        Member.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Member.py.html
#
"""
Implements the Member meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""


from Ft.Ods.MetaData import Specifier
from Ft.Ods.MetaData import MetaKind
from Ft.Ods.StorageManager.Adapters import Constants
from Ft.Ods import PersistentObject
td = PersistentObject.TupleDefinitions

class Member(Specifier.Specifier):
    def __init__(self,data=None):
        Specifier.Specifier.__init__(self,data,MetaKind.MetaKind.mk_member)

    def form_structure_type(self,target,inverse = 1):
        from Ft.Ods.MetaData import Structure
        self._4ods_formRelationship('structure_type',Structure.Structure,'fields','add',target,inverse)
    def drop_structure_type(self,target,inverse = 1):
        self._4ods_dropRelationship('structure_type','fields','remove',target,inverse)



    _tupleNames =  ('structure_type',)


    _tupleDefinitions = {'structure_type':{td.TYPE:Constants.Types.OBJECT,
                                           td.READONLY:1,
                                           td.RELATIONSHIP:1,
                                           },
                         }
                    
    _localExtents = ()
