########################################################################
#
# File Name: 	        Parameter.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Parameter.py.html
#
"""
Implements the Parameter meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""


from Ft.Ods.MetaData import Specifier
from Ft.Ods.MetaData import MetaKind
from Ft.Ods.MetaData import Direction
from Ft.Ods.StorageManager.Adapters import Constants
from Ft.Ods.Collections import LiteralCollection
from Ft.Ods import PersistentObject
td = PersistentObject.TupleDefinitions

class Parameter(Specifier.Specifier):
    def __init__(self,data=None,parameter_mode=None):
        Specifier.Specifier.__init__(self,data,MetaKind.MetaKind.mk_parameter)

        if data is None:
            if parameter_mode is None:
                raise "No PArameter Mode"
            self.__dict__['parameter_mode'] = parameter_mode

    def form_operation(self,target,inverse = 1):
        from Ft.Ods.MetaData import Operation
        self._4ods_formRelationship('operation',Operation.Operation,'signature','add',target,inverse)

    def drop_operation(self,target,inverse = 1):
        self._4ods_dropRelationship('operation','signature','remove',target,inverse)


    _tupleNames =  ('parameter_mode','operation')

    _tupleDefinitions = {'parameter_mode':{td.TYPE:Constants.Types.ENUMERATION,
                                           td.ENUM_CLASS:Direction.Direction,
                                           },
                         'operation':{td.TYPE:Constants.Types.OBJECT,
                                      td.READONLY:1,
                                      td.RELATIONSHIP:1,
                                      },
                         }
    
    _localExtents = ()

