########################################################################
#
# File Name: 	        Specifier.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Specifier.py.html
#
"""
Implements the Specifier meta-data interface.
WWW: http://4suite.com/4ODS         e-mail: support@4suite.com

Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
See  http://4suite.com/COPYRIGHT  for license and copyright information
"""

from Ft.Ods.MetaData import RepositoryObject
from Ft.Ods.StorageManager.Adapters import Constants

from Ft.Ods import PersistentObject
td = PersistentObject.TupleDefinitions

class Specifier(RepositoryObject.RepositoryObject):
    def __init__(self,data=None,metaKind=None):
        RepositoryObject.RepositoryObject.__init__(self,data,metaKind)

        if data == None:
            self.__dict__['name'] = ''


    def form_type(self,target,inverse = 1):
        from Ft.Ods.MetaData import Type
        self._4ods_formRelationship('type',Type.Type,'specifiers','add',target,inverse)

    def drop_type(self,target,inverse = 1):
        self._4ods_dropRelationship('type','specifiers','remove',target,inverse)


    _tupleNames =  ('name','type')

    _tupleDefinitions = {'name':{td.TYPE:Constants.Types.STRING,
                                 },
                         'type':{td.TYPE:Constants.Types.OBJECT,
                                 td.READONLY:1,
                                 td.RELATIONSHIP:1,
                                 },
                         }
    
    _localExtents = ()
