#!/usr/bin/python
########################################################################
#
# File Name:            GenerateConstant.py
#
# Documentation:        http://docs.4suite.com/4ODS/GenerateConstant.py.html
#

#Desc.
#WWW: http://4suite.com/4ODS        e-mail: support@4suite.com

#Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
#See  http://4suite.com/COPYRIGHT  for license and copyright information

from Ft.Ods.MetaData.MetaKind import MetaKind
from Ft.Ods.MetaData.PrimitiveKind import PrimitiveKind
import os

def GenerateStubs(c,params):

    if c.parent().parent() == None:
        fName = 'ODSGlobalDef.py'
    else:
        fName = os.path.join(params.curDir, '__init__.py')

    f = open(fName,'a')

    #We need to determine what the output value should be, ie with quotes, etc
    if c.type.meta_kind == MetaKind.mk_primitive_type:
        if c.type.primitive_kind == PrimitiveKind.pk_string:
            oString = '"' + c.value() + '"'
        elif c.type.primitive_kind == PrimitiveKind.pk_boolean:
            if c.value():
                oString = '1'
            else:
                oString = '0'
        elif c.type.primitive_kind == PrimitiveKind.pk_float:
            oString = str(c.value())
        elif c.type.primitive_kind == PrimitiveKind.pk_short:
            oString = str(c.value())
        else:
            raise "Unsupported Prime Type %s" % c.type.primitive_kind
    else:
        raise "Unsupported Constant Type %s" % c.type

    f.write("%s=%s\n" % (c.name,oString))
    f.close()
    return



#Database creation interface
def SetMetaId(const,db):
    id = db.newMetaId('Constant')
    const.metaId = id

def InitDb(const,db):
    db.createConstant(const)
