#!/usr/bin/python
########################################################################
#
# File Name:            GenerateEnumuration.py
#
# Documentation:        http://docs.4suite.com/4ODS/ParsedEnumType.py.html
#

#Desc.
#WWW: http://4suite.com/4ODS        e-mail: support@4suite.com

#Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
#See  http://4suite.com/COPYRIGHT  for license and copyright information

import os
# File creation algorithms
def GenerateStubs(enum, params):
    """File creation algorithms"""
    # Write our file
    enumName = enum.name
    outFileName = os.path.join(params.curDir, enumName+'.py')
    outFile = open(outFileName,'w')
    params.outFile = outFile

    outFile.write("# Generated file, don't edit!!!\n")
    
    # The names may be in wanky order, let's sort'em
    eNames = enum.elements[:]
    eNames.sort(SortByValue)

    outFile.write("class %sEnumMember:\n" % enumName)
    outFile.write("    def __int__(self): return self._v\n")
    outFile.write("    def __str__(self): return self._n\n")
    outFile.write('\n');

    outFile.write('class %s_stub:\n\n' % enumName)
    ctr = 0
    for e in eNames:
        outFile.write('    class %s(%sEnumMember):\n' % (e.name,enumName))
        outFile.write('        _n = "%s"\n' % e.name)
        outFile.write('        _v = %d\n' % e.value())
        ctr = ctr + 1
    outFile.write('\n')

    outFile.write('    def lookup(self, name):\n')
    outFile.write('        names = filter(lambda member, name=name: member._n == name,\n')
    outFile.write('                       self.elements)\n')
    outFile.write('        if names:\n')
    outFile.write('            return names[0]\n')
    outFile.write('        return ""\n\n')

    outFile.write('    def isMember(self, member):\n')
    outFile.write('        return hasattr(member, "__bases__") and member.__bases__[0] == %sEnumMember' % enumName)
    outFile.write('\n')
    elements = '    elements = ('
    padding = ' '*len(elements)
    outFile.write(elements)
    
    for enum in eNames:
        outFile.write('%s,\n%s' % (enum, padding))
    outFile.write(')\n\n')
    
    outFile.write('%s = %s_stub()\n' % (enumName,enumName))

    outFile.close()
    return

def SortByValue(left,right):
    return cmp(left.value(),right.value())
