#!/usr/bin/python
########################################################################
#
# File Name:            FILE
#
# Documentation:        http://docs.4suite.com/4ODS/Parsers/GenerateModule.py.html
#

#Desc.
#WWW: http://4suite.com/4ODS        e-mail: support@4suite.com

#Copyright (c) 1999 FourThought LLC, USA.   All Rights Reserved.
#See  http://4suite.com/COPYRIGHT  for license and copyright information

import os

from Ft.Ods.Parsers.Odl import GenerateUtils

def GenerateStubs(mod,params):
    #try and make our directory from the baseDir
    modDir = os.path.join(params.curDir, mod.name)
    if not os.path.exists(modDir):
        os.makedirs(modDir)
    elif os.path.exists(os.path.join(modDir, '__init__.py')):
        os.remove(os.path.join(modDir, '__init__.py'))

    mod_file = open(os.path.join(modDir, '__init__.py'), 'w')
    mod_file.write('# DO NOT EDIT THIS FILE!\n')
    mod_file.write('#\n')
    mod_file.write('# Python module %s generated by OdlParse\n' % mod.name)
    mod_file.close()

    params.curDir = modDir
    if params.curPackage:
        params.curPackage = params.curPackage + '.'
    params.curPackage = params.curPackage + mod.name
    GenerateUtils.WalkDefinitions(mod,'GenerateStubs',params)



