from Ft.Ods.MetaData.MetaKind import MetaKind

g_metaKindMap = {MetaKind.mk_module : 'GenerateModule',
                 MetaKind.mk_class : 'GenerateClass',
                 MetaKind.mk_interface : 'GenerateInterface',
                 MetaKind.mk_enumeration : 'GenerateEnumeration',
                 MetaKind.mk_structure : 'GenerateStructure',
                 MetaKind.mk_constant : 'GenerateConstant',
                 }

def WalkDefinitions(parent, cmd, params, executeCopy=1):
    for define in parent.defines:
        ExecuteDefinition(define, cmd, params, executeCopy)


def ExecuteDefinition(define, cmd, params, executeCopy=1):
    try:
        module = g_metaKindMap[define.meta_kind]
    except KeyError:
        raise RuntimeError('Unknown definition %s (%s)' % (define, define.meta_kind))

    package = __import__('Ft.Ods.Parsers.Odl.%s' % module, {}, {}, '*')
    func = getattr(package, cmd)

    if executeCopy:
        func(define, params.copy())
    else:
        func(define, params)
    return

def SubsetByClass(l,klass):
    rt = []
    for item in l:
        if isinstance(item,klass):
            rt.append(item)
    return rt
