import Odl
import OdlParserBase

from OdlParserBase import SyntaxException
from OdlParserBase import InternalException
from OdlParserBase import PrintSyntaxException
from OdlParserBase import PrintInternalException

class OdlParseTreeMapping(OdlParserBase.OdlParserBase):
	def __init__(self):
		OdlParserBase.OdlParserBase.__init__(self)
	def start(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'START'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def specification(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'SPECIFICATION'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def definition(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'DEFINITION'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def _class(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'CLASS'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def class_dcl(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None):
		newNode = {}
		newNode['TYPE'] = 'CLASS_DCL'
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def class_forward_dcl(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'CLASS_FORWARD_DCL'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def class_header(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None, arg4 = None, arg5 = None):
		newNode = {}
		newNode['TYPE'] = 'CLASS_HEADER'
		if arg5 == '%%FT-NT%%':
			newNode[5] = self.pop()
		else:
			newNode[5] = arg5
		if arg4 == '%%FT-NT%%':
			newNode[4] = self.pop()
		else:
			newNode[4] = arg4
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def type_property_list(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None):
		newNode = {}
		newNode['TYPE'] = 'TYPE_PROPERTY_LIST'
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def extent_spec(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'EXTENT_SPEC'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def key_spec(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'KEY_SPEC'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def key_list(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'KEY_LIST'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def key(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'KEY'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def property_list(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'PROPERTY_LIST'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def property_name(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'PROPERTY_NAME'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def module(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None, arg4 = None):
		newNode = {}
		newNode['TYPE'] = 'MODULE'
		if arg4 == '%%FT-NT%%':
			newNode[4] = self.pop()
		else:
			newNode[4] = arg4
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def interface(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'INTERFACE'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def interface_dcl(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None):
		newNode = {}
		newNode['TYPE'] = 'INTERFACE_DCL'
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def interface_forward_dcl(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'INTERFACE_FORWARD_DCL'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def interface_header(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'INTERFACE_HEADER'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def interface_body(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'INTERFACE_BODY'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def export(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'EXPORT'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def inheritance_spec(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None):
		newNode = {}
		newNode['TYPE'] = 'INHERITANCE_SPEC'
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def scoped_name(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'SCOPED_NAME'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def const_dcl(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None, arg4 = None):
		newNode = {}
		newNode['TYPE'] = 'CONST_DCL'
		if arg4 == '%%FT-NT%%':
			newNode[4] = self.pop()
		else:
			newNode[4] = arg4
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def const_type(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'CONST_TYPE'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def const_exp(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'CONST_EXP'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def or_expr(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'OR_EXPR'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def xor_expr(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'XOR_EXPR'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def and_expr(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'AND_EXPR'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def shift_expr(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None):
		newNode = {}
		newNode['TYPE'] = 'SHIFT_EXPR'
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def add_expr(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'ADD_EXPR'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def mult_expr(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'MULT_EXPR'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def unary_expr(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'UNARY_EXPR'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def unary_operator(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'UNARY_OPERATOR'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def primary_expr(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'PRIMARY_EXPR'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def literal(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'LITERAL'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def boolean_literal(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'BOOLEAN_LITERAL'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def positive_int_const(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'POSITIVE_INT_CONST'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def type_dcl(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'TYPE_DCL'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def type_declarator(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'TYPE_DECLARATOR'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def type_spec(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'TYPE_SPEC'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def simple_type_spec(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'SIMPLE_TYPE_SPEC'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def base_type_spec(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'BASE_TYPE_SPEC'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def date_type(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'DATE_TYPE'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def time_type(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'TIME_TYPE'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def blob_type(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'BLOB_TYPE'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def interval_type(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'INTERVAL_TYPE'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def timestamp_type(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'TIMESTAMP_TYPE'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def template_type_spec(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'TEMPLATE_TYPE_SPEC'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def coll_type(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None, arg4 = None, arg5 = None):
		newNode = {}
		newNode['TYPE'] = 'COLL_TYPE'
		if arg5 == '%%FT-NT%%':
			newNode[5] = self.pop()
		else:
			newNode[5] = arg5
		if arg4 == '%%FT-NT%%':
			newNode[4] = self.pop()
		else:
			newNode[4] = arg4
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def coll_spec(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'COLL_SPEC'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def constr_type_spec(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'CONSTR_TYPE_SPEC'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def declarators(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'DECLARATORS'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def declarator(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'DECLARATOR'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def simple_declarator(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'SIMPLE_DECLARATOR'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def complex_declarator(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'COMPLEX_DECLARATOR'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def floating_pt_type(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'FLOATING_PT_TYPE'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def integer_type(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'INTEGER_TYPE'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def signed_int(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'SIGNED_INT'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def signed_long_int(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'SIGNED_LONG_INT'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def signed_long_long_int(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'SIGNED_LONG_LONG_INT'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def signed_short_int(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'SIGNED_SHORT_INT'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def unsigned_int(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'UNSIGNED_INT'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def unsigned_long_int(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'UNSIGNED_LONG_INT'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def unsigned_short_int(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'UNSIGNED_SHORT_INT'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def char_type(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'CHAR_TYPE'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def boolean_type(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'BOOLEAN_TYPE'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def octet_type(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'OCTET_TYPE'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def struct_type(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None, arg4 = None):
		newNode = {}
		newNode['TYPE'] = 'STRUCT_TYPE'
		if arg4 == '%%FT-NT%%':
			newNode[4] = self.pop()
		else:
			newNode[4] = arg4
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def member_list(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'MEMBER_LIST'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def member(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'MEMBER'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def union_type(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None, arg4 = None, arg5 = None, arg6 = None, arg7 = None, arg8 = None):
		newNode = {}
		newNode['TYPE'] = 'UNION_TYPE'
		if arg8 == '%%FT-NT%%':
			newNode[8] = self.pop()
		else:
			newNode[8] = arg8
		if arg7 == '%%FT-NT%%':
			newNode[7] = self.pop()
		else:
			newNode[7] = arg7
		if arg6 == '%%FT-NT%%':
			newNode[6] = self.pop()
		else:
			newNode[6] = arg6
		if arg5 == '%%FT-NT%%':
			newNode[5] = self.pop()
		else:
			newNode[5] = arg5
		if arg4 == '%%FT-NT%%':
			newNode[4] = self.pop()
		else:
			newNode[4] = arg4
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def switch_type_spec(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'SWITCH_TYPE_SPEC'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def switch_body(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'SWITCH_BODY'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def case(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'CASE'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def case_label_list(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'CASE_LABEL_LIST'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def case_label(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'CASE_LABEL'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def element_spec(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'ELEMENT_SPEC'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def enum_type(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None, arg4 = None):
		newNode = {}
		newNode['TYPE'] = 'ENUM_TYPE'
		if arg4 == '%%FT-NT%%':
			newNode[4] = self.pop()
		else:
			newNode[4] = arg4
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def enumerator_list(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'ENUMERATOR_LIST'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def enumerator(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'ENUMERATOR'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def array_type(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None, arg4 = None, arg5 = None):
		newNode = {}
		newNode['TYPE'] = 'ARRAY_TYPE'
		if arg5 == '%%FT-NT%%':
			newNode[5] = self.pop()
		else:
			newNode[5] = arg5
		if arg4 == '%%FT-NT%%':
			newNode[4] = self.pop()
		else:
			newNode[4] = arg4
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def array_spec(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'ARRAY_SPEC'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def string_type(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None):
		newNode = {}
		newNode['TYPE'] = 'STRING_TYPE'
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def array_declarator(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'ARRAY_DECLARATOR'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def array_size_list(self, arg0 = None, arg1 = None):
		newNode = {}
		newNode['TYPE'] = 'ARRAY_SIZE_LIST'
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def fixed_array_size(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'FIXED_ARRAY_SIZE'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def attr_dcl(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None):
		newNode = {}
		newNode['TYPE'] = 'ATTR_DCL'
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def attr_list(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None):
		newNode = {}
		newNode['TYPE'] = 'ATTR_LIST'
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def attribute_name(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'ATTRIBUTE_NAME'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def domain_type(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'DOMAIN_TYPE'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def rel_dcl(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None, arg4 = None):
		newNode = {}
		newNode['TYPE'] = 'REL_DCL'
		if arg4 == '%%FT-NT%%':
			newNode[4] = self.pop()
		else:
			newNode[4] = arg4
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def target_of_path(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None):
		newNode = {}
		newNode['TYPE'] = 'TARGET_OF_PATH'
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def inverse_traversal_path(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'INVERSE_TRAVERSAL_PATH'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def except_dcl(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None, arg4 = None):
		newNode = {}
		newNode['TYPE'] = 'EXCEPT_DCL'
		if arg4 == '%%FT-NT%%':
			newNode[4] = self.pop()
		else:
			newNode[4] = arg4
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def op_dcl(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None, arg4 = None, arg5 = None):
		newNode = {}
		newNode['TYPE'] = 'OP_DCL'
		if arg5 == '%%FT-NT%%':
			newNode[5] = self.pop()
		else:
			newNode[5] = arg5
		if arg4 == '%%FT-NT%%':
			newNode[4] = self.pop()
		else:
			newNode[4] = arg4
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def op_attribute(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'OP_ATTRIBUTE'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def op_type_spec(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'OP_TYPE_SPEC'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def parameter_dcls(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'PARAMETER_DCLS'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def param_dcl_list(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None):
		newNode = {}
		newNode['TYPE'] = 'PARAM_DCL_LIST'
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def param_dcl(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'PARAM_DCL'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def param_attribute(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'PARAM_ATTRIBUTE'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def raises_expr(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None):
		newNode = {}
		newNode['TYPE'] = 'RAISES_EXPR'
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def scoped_name_list(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'SCOPED_NAME_LIST'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def context_expr(self, arg0 = None, arg1 = None, arg2 = None, arg3 = None):
		newNode = {}
		newNode['TYPE'] = 'CONTEXT_EXPR'
		if arg3 == '%%FT-NT%%':
			newNode[3] = self.pop()
		else:
			newNode[3] = arg3
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def string_literal_list(self, arg0 = None, arg1 = None, arg2 = None):
		newNode = {}
		newNode['TYPE'] = 'STRING_LITERAL_LIST'
		if arg2 == '%%FT-NT%%':
			newNode[2] = self.pop()
		else:
			newNode[2] = arg2
		if arg1 == '%%FT-NT%%':
			newNode[1] = self.pop()
		else:
			newNode[1] = arg1
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def string_literal(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'STRING_LITERAL'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def integer_literal(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'INTEGER_LITERAL'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def floating_pt_literal(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'FLOATING_PT_LITERAL'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)

	def character_literal(self, arg0 = None):
		newNode = {}
		newNode['TYPE'] = 'CHARACTER_LITERAL'
		if arg0 == '%%FT-NT%%':
			newNode[0] = self.pop()
		else:
			newNode[0] = arg0
		self.push(newNode)


if __name__ == '__main__':
	from Ft.Lib import DumpBgMapping
	import sys
	rt = []
	p = OdlParseTreeMapping()
	if len(sys.argv)==2:
		l = open(sys.argv[1],'r').read()
	else:
		l = raw_input(">>>")
	try:
		rt = p.parse(l)
		DumpBgMapping.Dump(rt)
	except InternalException, e:
		PrintInternalException(e)
	except SyntaxException, e:
		PrintSyntaxException(e)
