

#The constants for locking 
READ_LOCK=1
WRITE_LOCK=2
UPGRADE_LOCK=3


#System level repo IDS
g_systemLevelRepoIds = {'DBOBJECT':1,
                        'OBJECT':2,
                        'LITERAL':3,
                        'SCOPE':4,
                        'REPOSITORY_OBJECT':5,
                        'META_OBJECT':6,
                        'DEFINING_SCOPE':7,
                        'MODULE':8,

                        'STRING_LIST':40,
                        }


g_systemLevelTables = {2:'ftods_object',
                             3:'ftods_literal'
                             }


class Types:
    BOOLEAN = 1
    BOOLEAN_BAG = 2
    BOOLEAN_SET = 3
    BOOLEAN_LIST = 4
    SIGNED_SHORT = 5
    SIGNED_SHORT_BAG = 6
    SIGNED_SHORT_SET = 7
    SIGNED_SHORT_LIST = 8
    STRING = 9
    STRING_LIST = 10
    STRING_BAG = 11
    STRING_SET= 12
    UNSIGNED_SHORT = 13
    UNSIGNED_SHORT_BAG = 14
    UNSIGNED_SHORT_SET = 15
    UNSIGNED_SHORT_LIST = 16
    SIGNED_LONG = 17
    SIGNED_LONG_SET = 18
    SIGNED_LONG_BAG = 19
    SIGNED_LONG_LIST = 20
    UNSIGNED_LONG = 21
    UNSIGNED_LONG_LIST = 22
    UNSIGNED_LONG_BAG = 23
    UNSIGNED_LONG_SET = 24
    SIGNED_LONG_LONG = 25
    SIGNED_LONG_LONG_BAG = 26
    SIGNED_LONG_LONG_SET = 27
    SIGNED_LONG_LONG_LIST = 28
    FLOAT = 29
    FLOAT_BAG = 30
    FLOAT_SET = 31
    FLOAT_LIST = 32
    DOUBLE = 33
    DOUBLE_BAG = 34
    DOUBLE_SET = 35
    DOUBLE_LIST = 36


    OBJECT=37
    OBJECT_LIST = 38
    OBJECT_SET = 39
    OBJECT_BAG = 40

    ENUMERATION = 41
    LITERAL = 42
    STRUCTURE = 43
    DICTIONARY = 44

    ANY = 45


    BLOB=100



class ObjectTypes:
    REPO = 1
    OBJECT = 2
    LITERAL = 3
    COLLECTION = 4

class LiteralTypes:
    DICTIONARY = 1



g_listTypes = {
    Types.STRING:0,
    Types.UNSIGNED_SHORT:0,
    Types.BOOLEAN:0,
    Types.UNSIGNED_LONG:0,
    Types.SIGNED_SHORT:0,
    Types.DOUBLE:0,
    Types.SIGNED_LONG_LONG:0,
    Types.SIGNED_LONG:0,
    Types.FLOAT:0,
    Types.OBJECT:0,
    Types.ENUMERATION:0,
    Types.OBJECT_LIST:1,
    Types.OBJECT_SET:1,
    Types.OBJECT_BAG:1,
    Types.STRING_LIST:1,
    Types.STRING_BAG:1,
    Types.STRING_SET:1,
    Types.BOOLEAN_LIST:1,
    Types.BOOLEAN_BAG:1,
    Types.BOOLEAN_SET:1,
    Types.SIGNED_SHORT_LIST:1,
    Types.SIGNED_SHORT_BAG:1,
    Types.SIGNED_SHORT_SET:1,
    Types.UNSIGNED_SHORT_LIST:1,
    Types.UNSIGNED_SHORT_BAG:1,
    Types.UNSIGNED_SHORT_SET:1,
    Types.SIGNED_LONG_LIST:1,
    Types.SIGNED_LONG_BAG:1,
    Types.SIGNED_LONG_SET:1,
    Types.UNSIGNED_LONG_LIST:1,
    Types.UNSIGNED_LONG_BAG:1,
    Types.UNSIGNED_LONG_SET:1,
    Types.SIGNED_LONG_LONG_LIST:1,
    Types.SIGNED_LONG_LONG_BAG:1,
    Types.SIGNED_LONG_LONG_SET:1,
    Types.FLOAT_LIST:1,
    Types.FLOAT_BAG:1,
    Types.FLOAT_SET:1,
    Types.DOUBLE_LIST:1,
    Types.DOUBLE_BAG:1,
    Types.DOUBLE_SET:1,
    Types.ANY:0,
    Types.BLOB:0
    }


g_primitiveTypes = {
    Types.STRING:1,
    Types.UNSIGNED_SHORT:1,
    Types.BOOLEAN:1,
    Types.UNSIGNED_LONG:1,
    Types.SIGNED_SHORT:1,
    Types.DOUBLE:1,
    Types.SIGNED_LONG_LONG:1,
    Types.SIGNED_LONG:1,
    Types.FLOAT:1,
    Types.BLOB:0,
    Types.OBJECT:0,
    Types.ENUMERATION:0,
    Types.OBJECT_LIST:0,
    Types.OBJECT_SET:0,
    Types.OBJECT_BAG:0,
    Types.STRING_LIST:0,
    Types.STRING_BAG:0,
    Types.STRING_SET:0,
    Types.BOOLEAN_LIST:0,
    Types.BOOLEAN_BAG:0,
    Types.BOOLEAN_SET:0,
    Types.SIGNED_SHORT_LIST:0,
    Types.SIGNED_SHORT_BAG:0,
    Types.SIGNED_SHORT_SET:0,
    Types.UNSIGNED_SHORT_LIST:0,
    Types.UNSIGNED_SHORT_BAG:0,
    Types.UNSIGNED_SHORT_SET:0,
    Types.SIGNED_LONG_LIST:0,
    Types.SIGNED_LONG_BAG:0,
    Types.SIGNED_LONG_SET:0,
    Types.UNSIGNED_LONG_LIST:0,
    Types.UNSIGNED_LONG_BAG:0,
    Types.UNSIGNED_LONG_SET:0,
    Types.SIGNED_LONG_LONG_LIST:0,
    Types.SIGNED_LONG_LONG_BAG:0,
    Types.SIGNED_LONG_LONG_SET:0,
    Types.FLOAT_LIST:0,
    Types.FLOAT_BAG:0,
    Types.FLOAT_SET:0,
    Types.DOUBLE_LIST:0,
    Types.DOUBLE_BAG:0,
    Types.DOUBLE_SET:0,
    Types.ANY:1,
    Types.BLOB:0
    }






class CollectionChanges:
    INSERT = 1
    REMOVE = 2
    APPEND = 3
    REMOVE_END = 4


class CollectionTypes:
    LIST = 1
    BAG = 2
    SET = 3
