#!/usr/bin/env python
############################################################################
#  
#  Copyright (c)2000 FourThought, Inc.
#  http://ftsuite.com/4ODS
#
############################################################################
#
# File Name: 		4odb_clean.py
#
# Documentation:	http://docs.ftsuite.com/4ODS/Tools/4odb_clean.py.html
#


#A Tool for removing all unaccessible objects from the database (Garbage Collections)

import sys

def PrintUsage(program):
    import Ft
    print '4ODS version %s' % Ft.__version__
    print
    print 'Remove all objects from the database that are not accessible from either an extent or a bound name'
    print
    print 'Usage: %s <database name>' % program
    return

def Run(argv):
    if len(argv) != 2:
        PrintUsage(argv[0])
        sys.exit(1)

    from Ft.Ods.StorageManager import Adapters
    Adapters.GetManager().clean(argv[1])

if __name__ == '__main__':
    Run(sys.argv)
    
