class BaseException(Exception):
    def __init__(self, name,errorCode,msg=None):
        Exception.__init__(self,msg or name)
        self.errorCode = errorCode

class IntegrityException(BaseException):
    def __init__(self, relName, errorCode=0):
        BaseException.__init__(self, "IntegrityException",errorCode,"Integrity error on relationship %s" % str(relName))
        self.relName = relName

class FtodsBindingException(BaseException):
    NAME_ALREADY_IN_USE = 1
    NAME_NOT_BOUND = 2
    def __init__(self, name, errorCode=0):
        BaseException.__init__(self, "FtodsBindingException",errorCode,"Error Binding %s" % name)
        self.name = name

class FtodsParseError(BaseException):
    TOO_MANY_TOP_LEVEL = 1
    WRONG_TOP_LEVEL = 2
    UNDEFINED_SCOPED_NAME = 3
    SYMBOL_REDEFINITION = 4
    BROKEN_TREE = 5
    INVALID_SCOPED_NAME = 6
    def __init__(self,errorCode,msg=''):
        m = ''
        if errorCode == 1:
            m = "TOO_MANY_TOP_LEVEL"
        elif errorCode == 2:
            m = "WRONG_TOP_LEVEL"
        elif errorCode == 3:
            m = "UNDEFINED SYMBOL"
        elif errorCode == 4:
            m = "symbol redefined"
        elif errorCode == 5:
            m = "unanchored tree at"
        elif errorCode == 6:
            m = "Invalid Scoped Name"
        m = m + ": " + msg
            
        BaseException.__init__(self,m,errorCode)

    
        
class FtodsUnsupportedError(BaseException):
    def __init__(self,feature):
        BaseException.__init__(self,"%s not supported" % feature,0)
        self.feature = feature

class FtodsObjectNotFound(BaseException):
    def __init__(self,oid):
        BaseException.__init__(self,"Object %s not found" % str(oid),0)
        self.oid = oid


def FreePersistentObject(obj):
    obj._pseudo_del()


import Ft.Ods.MetaData
