from XPtrException import XPtrException
from Ft.Lib import Uri
import Ft.Lib
import os
BETA_DOMLETTE = os.environ.get("BETA_DOMLETTE")
if BETA_DOMLETTE:
    from Ft.Lib import cDomlette
    g_domModule = cDomlette
    g_readerClass = cDomlette.RawExpatReader
else:
    from Ft.Lib import pDomlette
    g_domModule = pDomlette
    g_readerClass = pDomlette.PyExpatReader


from xml.sax.saxlib import SAXException, SAXParseException
import urllib

def SelectUri(uri, contextNode=None, nss=None, reader=g_readerClass(),
              base=''):
    """
    Takes a URI and splits it into an url and fragment that can be
    consumed by SelectNode.
    """
    import urllib
    base, fragment = urllib.splittag(uri)
    if fragment is None:
        return reader.fromUri(uri, baseUri=base)
    fragment = urllib.unquote(fragment)
    try:
        doc = reader.fromUri(base, baseUri=base)
    except SAXException, e:
        raise XPtrException(XPtrException.RESOURCE_ERROR, e)
    except Ft.Lib.FtException, e:
        raise e
    except:
        import traceback
        traceback.print_exc()
        raise XPtrException(XPtrException.RESOURCE_ERROR)
    return SelectNode(doc, fragment, nss, contextNode)

from XPointerParserBase import SyntaxException, InternalException

#NOTE: We need to override xml.utils.boolean
from xml import utils
import Ft.extensions.boolean
utils.boolean = Ft.extensions.boolean

def SelectNode(doc, fragment, nss=None, contextNode=None):
    """
    Accepts a valid DOM node and a unescaped fragment.
    """
    import XPointerParser
    parser = XPointerParser.XPointerParser()
    try:
        xptr = parser.parseFragment(fragment)
    except SyntaxException, e:
        raise XPtrException(XPtrException.SYNTAX_ERROR, e)
    except InternalException, e:
        raise XPtrException(XPtrException.SYNTAX_ERROR, e)
    except:
        raise XPtrException(XPtrException.SYNTAX_ERROR)
    return xptr.select(doc, contextNode, nss)


def Init():
    import xml.xpath
    xml.xpath.RegisterExtensionModules(['Ft.XPointer.XPtrFunctions'])

Init()
    
